<script lang="ts" context="module">
export async function load({session, page}) {
    let auth = await Api.Auth.check(session.sess).then(a => a).catch(() => undefined);
    if (!auth) {
        return {
            status: 302,
            redirect: '/login?to=' + ('/users/' + page.params.id)
        }
    }
    return {
        props: {
            user: await Api.User.get(session.sess, page.params.id),
            entries: (await Api.User.log(session.sess, page.params.id)).sort((a, b) => (a.joined - b.joined)),
            sess: session.sess,
            authUsr: await Api.User.get(session.sess, auth.sessionInfo.user)
        }
    }
}
</script>
<script lang="ts">
import { goto } from '$app/navigation';

import * as Api from '../../../api/Api';
import Button from '../../../components/Button.svelte';
import { formatDate, formatDuration } from '../../../util/DateFormat';

export let user: Api.UserInfo, entries: Array<Api.LogInfo>, sess: string, authUsr: Api.UserInfo;

const maxDur = 7 * 60 * 60; // 7hrs

// TODO: optimize
let totalTime = 0;
let bsTime = 0; // build season time
entries.forEach(entry => {
    if (entry.left - entry.joined <= maxDur) { // TODO: abstract this condition
        totalTime += (entry.left - entry.joined);
        if (entry.joined > 1641625200) { // 8 Jan 2022 @ 00:00 (kickoff day)
            bsTime += (entry.left - entry.joined);
        }
    }
});

let promoteHandler = () => {
    Api.User.chsudo(sess, user.usr, 1).then(() => goto('/users/' + user.usr))
        .catch(() => goto('/error?from=user-chsudo'));
}
</script>
<style>
    .sudo-icon {
        color: #ebebeb;
        background-color: #3d3d3d;
        padding: 0px 5px;
        border-radius: 15px;
        font-weight: 600;
        font-size: 0.8rem;
        padding: 0.1rem 0.5rem 0.15rem 0.5rem;
        vertical-align: 0.15rem;
    }
    .entries {
        width: 100%;
        border-collapse: collapse;
        font-size: 0.8rem;
    }

    .entries tbody tr:nth-child(odd) {
        background-color: #dddddd;
    }

    tr.dur-invalid {
        background-color: #df7373 !important;
    }
</style>

<svelte:head>
    <title>{user.name} | Users | AZtendance</title>
</svelte:head>

<h2>{user.name}</h2>
<h3>{user.usr} {#if user.sudo}<span class="sudo-icon">sudo</span>{/if}</h3>
<p>
    Total time: {formatDuration(totalTime)}<br>
    Build season time: {formatDuration(bsTime)}
</p>
<table class="entries">
    <thead>
        <tr>
            <th>Start</th>
            <th>End</th>
            <th>Dur</th>
            <th>Loc</th>
            <th>MID</th>
        </tr>
    </thead>
    <tbody>
        {#each entries as entry}
        <tr class="{entry.left - entry.joined <= maxDur ? "dur-valid" : "dur-invalid"}">
            <td data-ts={entry.joined}>{formatDate(new Date(entry.joined * 1000))}</td>
            <td data-ts={entry.left}>{formatDate(new Date(entry.left * 1000))}</td>
            <td>{formatDuration(entry.left - entry.joined)}</td>
            <td>{entry.loc}</td>
            <td>{entry.id}</td>
        </tr>
        {/each}
    </tbody>
</table>
{#if authUsr.sudo || authUsr.usr == user.usr}
<h3>User Options</h3>
<Button content="Change Password" theme="secondary" href="/users/{user.usr}/passwd" />
<Button content="Rename" theme="secondary" href="/users/{user.usr}/rename" />
{/if}
{#if authUsr.sudo}
<h3>Sudo Options</h3>
<Button content="Promote" theme="secondary" onclick={promoteHandler} />
{/if}